/* include/gdt.h */
#ifndef __GDT_H
#define __GDT_H

/* define gdt entry - packed prevents compiler from dorking it up */
struct gdt_entry
{
	unsigned short limit_lo;
	unsigned short base_lo;
	unsigned char  base_mid;
	unsigned char  access;
	unsigned char  granularity;
	unsigned char  base_hi;
} __attribute__ ((__packed__));

/* special pointer - max bytes taken by gdt - 1 */
struct gdt_ptr
{
	unsigned short limit;
	unsigned int  base;
} __attribute__ ((__packed__));

/* a simple 3-entry gdt and pointer */
struct gdt_entry gdt[3];
struct gdt_ptr gp;

/* the extern function in loader.asm */
extern void gdt_flush();

void gdt_set_gate(int num, unsigned long base, unsigned long lim, unsigned char access, unsigned char gran);
void gdt_install();

#endif
