/* include/idt.h */

#ifndef __IDT_H
#define __IDT_H

/* idt entry */
struct idt_entry
{
	unsigned short base_lo;
	unsigned short sel;	/* kernel segment goes here */
	unsigned char always0;	/* always set 0 */
	unsigned char flags;	/* set with above table */
	unsigned char base_hi;
} __attribute__ ((packed));

/* idt pointer */
struct idt_ptr
{
	unsigned short limit;
	unsigned int base;
} __attribute__ ((packed));

/* delare 256 entry idt - if an undefined idt entry is hit
 * it will cause an "unhandled exception".  any descriptor that has
 * the presence but cleared (0) will generate an "unhandled exception" */
struct idt_entry idt[256];
struct idt_ptr idtp;

/* this is in loader.asm and loads idt */
extern void idt_load();

void idt_set_gate(unsigned char, unsigned long, unsigned short, unsigned char);
void idt_install();

#endif
