#ifndef __ISRS_H
#define __ISRS_H

/* register after an isr */
struct regs
{
	/* segments were pushed last */
	unsigned int gs, fs, es, ds;
	/* pushed by pusha */
	unsigned int edi, esi, ebp, esp, ebx, edx, ecx, eax;
	/* push byte # and ecodes do this */
	unsigned int int_no, err_code;
	/* pushed by processor automatically */
	unsigned int eip, cs, eflags, useresp, ss;
};

/* funtion prototypes for all exception handlers and first 32 are
 * reserved by intel corp for service exceptions */
extern void isr0();
extern void isr8();
extern void isr13();

void isrs_install();
void fault_handler(struct regs *);

#endif
