#include <screen.h>
#include <gdt.h>
#include <idt.h>
#include <isrs.h>

/* kernel main() */
int main()
{
	/* disable interrupts */
	__asm__ __volatile__ ("cli");

	/* initialize gdt */
	gdt_install();

	/* initialize idt and isrs */
	idt_install();
	isrs_install();

	/* enable interrupts */
	__asm__ __volatile__ ("sti");

	/* initialize video */
	init_video();
	cls();

	/* all commands go below */
	settextcolor(WHITE,BLUE);
	puts("Test Kernel 0.1\n");
	puts("---------------\n");

#ifdef DEBUG
	int test;
	test = 1 / 0;
	puts("DEBUG: ");
	puts(test);
#endif

	/* loop forever - do not return to start.asm jmp $ */
	/* for ( ; ; ) ; */

	puts("I GOT HERE!\n");
	/* return -1; */
	puts("I GOT HERE, TOO!\n");
}
